/**
  *  \file planetscentral/format/specpacker.h
  *  \brief Format - Specification Files
  */
#ifndef C2SERVER_PLANETSCENTRAL_FORMAT_SPECPACKER_H
#define C2SERVER_PLANETSCENTRAL_FORMAT_SPECPACKER_H

#include "planetscentral/format/packer.h"

/** Packer for ENGSPEC files. */
class EnginePacker : public Packer {
 public:
    virtual string_t pack(IntValue* data);
    virtual IntValue* unpack(const string_t& data);
};

/** Packer for TORPSPEC files. */
class TorpedoPacker : public Packer {
 public:
    virtual string_t pack(IntValue* data);
    virtual IntValue* unpack(const string_t& data);
};

/** Packer for BEAMSPEC files. */
class BeamPacker : public Packer {
 public:
    virtual string_t pack(IntValue* data);
    virtual IntValue* unpack(const string_t& data);
};

/** Packer for HULLSPEC files. */
class HullPacker : public Packer {
 public:
    virtual string_t pack(IntValue* data);
    virtual IntValue* unpack(const string_t& data);
};

/** Packer for TRUEHULL files. */
class TruehullPacker : public Packer {
 public:
    virtual string_t pack(IntValue* data);
    virtual IntValue* unpack(const string_t& data);
};

#endif
